/** ALOE headers
 */
#include <phal_sw_api.h>
#include <math.h>
#include <swapi_utils.h>

#include "typetools.h"

#include "itf_types.h"
#include "inputs.h"
#include "outputs.h"
#include "stats.h"

#include "fdacoefs.h"

#define MAX_LENGTH 1024

int *filter;
int *mem;

float gain=1.0;

int process_input(int len)
{
    int i;
    int nsamples;
    int avg;

    nsamples=typeNsamplesArray(datatype,len);

    type2int(input_data,input_i,nsamples,datatype);
    
    for (i=0;i<nsamples;i++) {
        if (abs(input_i[i])>threshold) {
            input_i[i]*=gain;
            avg=convii(filter,mem,avg_length,abs(input_i[i]))/avg_length;
            if (avg>1) {
                if (!direct) {                    
                    if (amplitude>avg+step_th)
                        gain+=step;
                    if (amplitude<avg-step_th)
                        gain-=step;    
                } else {
                    gain=(float) amplitude/avg;                    
                }
            }
            if (gain>max_gain) {
                gain=max_gain;
            }
            if (gain<step)
                gain=step;
            if (gain<=0)
                gain=0.0001;
        }
        gain_vect[i]=gain;
    }

    int2type(input_i,output_data,nsamples,datatype);
    
    /* send throught output */
    SendItf(0,len);

    return 1;
}

/** Run function.
 * @return 1 if ok, 0 if error
 */
int RunCustom()
{
    return 1;
}

int InitCustom()
{
    int i;

    if (use_fda) {
        avg_length=BL;
        filter = B;
    } else {
        filter = malloc(sizeof(int)*avg_length);
        if (!filter) {
            printf("Error allocating filter memory (agc)\n");
            return 0;
        }
        for (i=0;i<avg_length;i++)
            filter[i]=1;
    }

    mem=calloc(1,sizeof(int)*avg_length);
    if (!mem) {
        printf("Error allocating filter memory (agc)\n");
        return 0;
    }
    
    return 1;
}


void ConfigInterfaces()
{
    
}



