/** ALOE headers
 */
#include <phal_sw_api.h>
#include <math.h>
#include <swapi_utils.h>

#include "typetools.h"

#include "itf_types.h"
#include "inputs.h"
#include "outputs.h"
#include "stats.h"

int numbits;

int tticnt;

int fixed_sequence[DIV4(OUTPUT_MAX_DATA)];


int get_output_length()
{
    if (!tticnt) {
        return DIV8(numbits);
    }
    return 0;
}


int generate_output(int len)
{
    int i;
    int *x=(int*) output_data;
    int r;
    int bit,j;

    if (!len)
        return 1;

    if (!datatype) {
        r=0;
        if (!do_random) {
            for (i=0;i<DIV4(len);i++) {
                if (ones) {
                    x[i]=0xffffffff;
                } else if (zeros) {
                    x[i]=0;
                } else {
                    x[i]=fixed_sequence[i];
                }
                r+=x[i];
            }
        } else {
            for (i=0;i<DIV4(len);i++) {
                x[i]=rand();
            }
        }
        if (!r) {
            Log("caution generated zeroes\n");
        }
    } else {
        for (i=0;i<numbits/rate;i++) {
            bit=rand()%2;
            for (j=0;j<rate;j++) {
                output_i[i*rate+j]=bit;
            }
        }
        int2type(output_i,output_data,numbits,datatype);
    }
    return len;
}


int process_control(int len)
{
    tti = ctrlpkt.tti;
    numbits = ctrlpkt.numbits;
    SetStatsValue(stat_numbits,&numbits,1);
    stnumbits=numbits;
    Log("BINSOURCE: length=%d tti=%d tticnt is %d\n",numbits,tti,tticnt);
    tticnt=0;
}
int sttest=0;
float snr=10.0;
/** Run function.
 * @return 1 if ok, 0 if error
 */
int RunCustom()
{
    if (stnumbits!=numbits) {
        numbits=stnumbits;
        Log("BINSOURCE: Generating %d bits\n",numbits);
        tticnt=0;
    }

    tticnt++;
    if (tticnt==tti)
        tticnt=0;
    return 1;
}

int InitCustom()
{
    int i;
    tticnt=-1;
      for (i=0;i<DIV4(stnumbits);i++) {
        fixed_sequence[i]=rand();
      }
    return 1;
}

void ConfigInterfaces(){}



